
@ECHO OFF
rem set C_FILES=main testnonbanking
rem set ASM_FILES=cstartup
rem SET ADD_LINK_FILES=..\mylibb\mylibb
rem set ADD_TO_SCL_FILES=
rem set BAS_LOAD=
rem set XCL_FILE=

CLS
setlocal enabledelayedexpansion

set Z80_IDE_PATH=..\z80\

set ICCZ80=%Z80_IDE_PATH%bin\iccz80
set AZ80=%Z80_IDE_PATH%bin\az80
set TRDTOOL=%Z80_IDE_PATH%bin\trdtool
set C_OPTIONS=-v0 -uua -q -e -K -gA -s9 -t4 -T -Llist\ -Olist\ -Alist\ -I"%Z80_IDE_PATH%inc/"
set LINK_OPTIONS=-cZ80 -Ilist -FMOTOROLA -C %Z80_IDE_PATH%lib\clzx128k -o list\aout.a01 -l list/cout.html -xehinms -R -w47

if "%1"=="buildscl" goto cropmodule

if not exist list mkdir list
if not exist bin mkdir bin
if not exist Cstartup.s01 copy %Z80_IDE_PATH%iccz80\Cstartup128kBanking.s01 Cstartup.s01

echo ---------------Compiling C_FILES---------------
FOR %%a IN (!C_FILES!) do (
	SET ADD_LINK_FILES=!ADD_LINK_FILES! %%a.r01
	set OPT_FIX=
	FINDSTR /RMBC:"#define.*FIX_THIS_NON_BANKING" %%a.c >nul
	if errorlevel 1 (SET OPT_FIX=-mb) ELSE (SET OPT_FIX=-DMEMORY_ATTRIBUTE=banked -ml)
	ECHO %%a.c !OPT_FIX!
	%ICCZ80% %C_OPTIONS% !OPT_FIX! %%a > err.log & if errorlevel 1 goto errexit
	FINDSTR "Warning[" err.log >nul & if NOT errorlevel 1 TYPE err.log
)

echo --------------Compiling ASM_FILES--------------
FOR %%a IN (!ASM_FILES!) do (
	SET ADD_LINK_FILES=!ADD_LINK_FILES! %%a.r01
	set OPT_FIX=
	IF /I %%a==cstartup SET OPT_FIX=-Dbanking
	ECHO %%a.s01 !OPT_FIX!
	%AZ80% -Olist\ -uu !OPT_FIX! %%a > err.log & if errorlevel 1 goto errexit
	FINDSTR "Warning[" err.log >nul & if NOT errorlevel 1 TYPE err.log
)

echo --------Fixing NO_INIT segments to CODE--------
FOR %%a IN (!C_FILES!) do (
	FINDSTR /RMBC:"#define.*FIX_NO_INIT_2_CODE" %%a.c >nul & if NOT errorlevel 1 (
		ECHO %%a.s01
		%Z80_IDE_PATH%bin\xlib -c "RENAME-SEGMENT list\%%a.r01 NO_INIT CODE" > err.log
		if errorlevel 1 goto errexit
	)
)

echo ------------------Linking files----------------
if "!XCL_FILE!"=="" set XCL_FILE=easy.xcl
if not exist !XCL_FILE! (echo creating !XCL_FILE!
echo -P^(CODE^)CODE=[10C000-10FFFE]*2+10000,[13C000-13FFFE]*2+10000,[16C000-16FFFE]*2+10000>!XCL_FILE!
echo -Z^(CODE^)RCODE,CDATA0,CONST,CSTR,CCSTR=6000-7FFF0>>!XCL_FILE!
echo -Z^(DATA^)DATA0,IDATA0,UDATA0,ECSTR,ALIGN8^|8,CSTACK+200=8000-BFFF>>!XCL_FILE!
echo -e_medium_write=_formatted_write>>!XCL_FILE!
echo -e_medium_read=_formatted_read>>!XCL_FILE!
)
if not "!ADD_LINK_FILES!"=="" (
	echo !ADD_LINK_FILES!
	%Z80_IDE_PATH%bin\xlink !ADD_LINK_FILES! %LINK_OPTIONS% -f !XCL_FILE! > err.log & if errorlevel 1 goto errexit
	FINDSTR "Warning[" err.log >nul & if NOT errorlevel 1 TYPE err.log
)

:cropmodule
echo ----------------Crop binary file---------------
rem del /Q bin\*.* 
%Z80_IDE_PATH%\srecord\srec_cat list\aout.a01 -offset -0x6000 -crop 0 0x6000 -o bin\code.c -Binary
FOR %%i IN (00,01,03,04,06,07,10,11,13,14,16,17) do (
	%Z80_IDE_PATH%\srecord\srec_cat list\aout.a01 -offset -0x%%~iC000 -crop 0 0x4000 -o bin\%%~i.c -Binary > err.log
	if errorlevel 1 goto errexit
)
for /R bin\ %%i in (*.c) do if %%~zi==0 (del /Q %%i) ELSE (echo file:%%~nxi size:%%~zi out^(7FFD^),0x%%~ni & SET BIN_FILES=!BIN_FILES! %%i)

if "!BAS_LOAD!"=="" (
	set BAS_LOAD=list\basic_loader
	echo -------------Generate Basic loader-------------
call :genbasasm
	%AZ80% !BAS_LOAD! -Olist\ > err.log & if errorlevel 1 goto errexit
	%Z80_IDE_PATH%bin\xlink -A !BAS_LOAD! -cZ80 -Z^(CODE^)BASIC=5D3B -Fraw-binary -o bin\boot.B > err.log & if errorlevel 1 goto errexit
	%TRDTOOL% bin\boot.B > err.log & if errorlevel 1 goto errexit
	del /Q bin\boot.B & echo BOOT.$B & set BAS_LOAD=bin\boot.$B
)

echo ---------------Generate test.SCL---------------
%TRDTOOL% # test.scl > err.log & if errorlevel 1 goto errexit
for %%i in (!BAS_LOAD! !BIN_FILES! !ADD_TO_SCL_FILES!) do (
	%TRDTOOL% + test.scl %%i > err.log & if errorlevel 1 goto errexit
	echo %%~nxi
)

exit /b

:errexit
TYPE err.log
pause
exit /b

:genbasasm
echo 	NAME	basic_loader >!BAS_LOAD!.s01
echo 	RSEG	BASIC >>!BAS_LOAD!.s01
echo basic_loader >>!BAS_LOAD!.s01
echo str10:	defb	0x00,10,LOW^(str10len^),HIGH^(str10len^),0xea >>!BAS_LOAD!.s01
echo 	di >>!BAS_LOAD!.s01
echo 	ld sp,0x6000 >>!BAS_LOAD!.s01
echo 	ld hl,filestruct >>!BAS_LOAD!.s01
echo mloop: ld a,(hl) >>!BAS_LOAD!.s01
echo 	or a >>!BAS_LOAD!.s01
echo 	jp m,0x6000 >>!BAS_LOAD!.s01
echo 	inc hl >>!BAS_LOAD!.s01
echo 	ld bc,0x7ffd >>!BAS_LOAD!.s01
echo 	out ^(c^),a >>!BAS_LOAD!.s01
echo 	push hl >>!BAS_LOAD!.s01
echo 	ld c,0x13 >>!BAS_LOAD!.s01
echo 	call 0x3d13 >>!BAS_LOAD!.s01
echo 	pop hl >>!BAS_LOAD!.s01
echo 	ld bc,9 >>!BAS_LOAD!.s01
echo 	add hl,bc >>!BAS_LOAD!.s01
echo 	ld e,(hl) >>!BAS_LOAD!.s01
echo 	inc hl >>!BAS_LOAD!.s01
echo 	ld d,(hl) >>!BAS_LOAD!.s01
echo 	inc hl >>!BAS_LOAD!.s01
echo 	push hl >>!BAS_LOAD!.s01
echo 	ex de,hl >>!BAS_LOAD!.s01
echo 	ld a,0xff >>!BAS_LOAD!.s01
echo 	ld c,0x0e >>!BAS_LOAD!.s01
echo 	call 0x3d13 >>!BAS_LOAD!.s01
echo 	pop hl >>!BAS_LOAD!.s01
echo 	jr mloop >>!BAS_LOAD!.s01
echo 	defs 32 >>!BAS_LOAD!.s01
echo filestruct: >>!BAS_LOAD!.s01
for %%l in (!BIN_FILES!) do (
	if %%~nl==code (echo 	defb 0x10,'code    C',0x00,0x60>>!BAS_LOAD!.s01) else (
	echo 	defb 0x%%~nl,'%%~nl      C',0x00,0xc0>>!BAS_LOAD!.s01)
)
echo 	defb	0xff,'\r' >>!BAS_LOAD!.s01
echo str10len=$-str10-4 >>!BAS_LOAD!.s01
echo str1 	defb 0x00,20,LOW^(str1len^),HIGH^(str1len^),0xfd,0xb0,'\"24575\"\r'>>!BAS_LOAD!.s01
echo str1len=$-str1-4>>!BAS_LOAD!.s01
echo str30	defb	0x00,30,LOW^(str30len^),HIGH^(str30len^),0xf9,0xc0,0xb0,'\"23872\"\r'>>!BAS_LOAD!.s01
echo str30len=$-str30-4>>!BAS_LOAD!.s01
echo 	defb	0x80>>!BAS_LOAD!.s01
echo 	END>>!BAS_LOAD!.s01
exit /b
